## nanopb 0.4.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

project(nanopb C)

set(nanopb_VERSION_STRING nanopb-0.4.1)
set(nanopb_SOVERSION 0)

string(REPLACE "nanopb-" "" nanopb_VERSION ${nanopb_VERSION_STRING})

option(BUILD_SHARED_LIBS "Build shared libraries" OFF)
option(BUILD_STATIC_LIBS "Build static libraries" ON)

option(nanopb_BUILD_RUNTIME "Build the headers and libraries needed at runtime" ON)
option(nanopb_BUILD_GENERATOR "Build the protoc plugin for code generation" ON)
option(nanopb_MSVC_STATIC_RUNTIME "Link static runtime libraries" ON)

if(NOT DEFINED nanopb_PROTOC_PATH)
    set(nanopb_PROTOC_PATH "protoc")
endif()

if(NOT DEFINED CMAKE_DEBUG_POSTFIX)
    set(CMAKE_DEBUG_POSTFIX "d")
endif()

include(GNUInstallDirs)

if(MSVC AND nanopb_MSVC_STATIC_RUNTIME)
    foreach(flag_var
            CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
            CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
        if(${flag_var} MATCHES "/MD")
            string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
        endif(${flag_var} MATCHES "/MD")
    endforeach(flag_var)
endif()

if(NOT DEFINED CMAKE_INSTALL_CMAKEDIR)
    set(CMAKE_INSTALL_CMAKEDIR "${CMAKE_INSTALL_LIBDIR}/cmake/nanopb")
endif()

if(nanopb_BUILD_GENERATOR)
    set(generator_protos nanopb)

    find_package(PythonInterp 2.7 REQUIRED)
    execute_process(
        COMMAND ${PYTHON_EXECUTABLE} -c
            "from distutils import sysconfig; print(sysconfig.get_python_lib(prefix=''))"
        OUTPUT_VARIABLE PYTHON_INSTDIR
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )

    foreach(generator_proto IN LISTS generator_protos)
        string(REGEX REPLACE "([^;]+)" "${PROJECT_SOURCE_DIR}/generator/proto/\\1.proto" generator_proto_file "${generator_proto}")
        string(REGEX REPLACE "([^;]+)" "\\1_pb2.py" generator_proto_py_file "${generator_proto}")
        add_custom_command(
            OUTPUT ${generator_proto_py_file}
            COMMAND ${nanopb_PROTOC_PATH} --python_out=${PROJECT_BINARY_DIR} -I${PROJECT_SOURCE_DIR}/generator/proto ${generator_proto_file}
            DEPENDS ${generator_proto_file}
        )
        add_custom_target("generate_${generator_proto_py_file}" ALL DEPENDS ${generator_proto_py_file})
        install(
            FILES ${PROJECT_BINARY_DIR}/${generator_proto_py_file}
			DESTINATION ${PYTHON_INSTDIR}
        )
    endforeach()
endif()

if(nanopb_BUILD_RUNTIME)
    if(BUILD_SHARED_LIBS)
        add_library(protobuf-nanopb SHARED
            pb.h
            pb_common.h
            pb_common.c
            pb_encode.h
            pb_encode.c
            pb_decode.h
            pb_decode.c)
        set_target_properties(protobuf-nanopb PROPERTIES
            SOVERSION ${nanopb_SOVERSION})
        install(TARGETS protobuf-nanopb EXPORT nanopb-targets
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
        target_include_directories(protobuf-nanopb INTERFACE
          $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
        )
    endif()

    if(BUILD_STATIC_LIBS)
        add_library(protobuf-nanopb-static STATIC
            pb.h
            pb_common.h
            pb_common.c
            pb_encode.h
            pb_encode.c
            pb_decode.h
            pb_decode.c)
        set_target_properties(protobuf-nanopb-static PROPERTIES
            OUTPUT_NAME protobuf-nanopb)
        install(TARGETS protobuf-nanopb-static EXPORT nanopb-targets
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
        target_include_directories(protobuf-nanopb-static INTERFACE
          $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
        )
    endif()

    configure_file(extra/nanopb-config-version.cmake.in
        nanopb-config-version.cmake @ONLY)

    install(EXPORT nanopb-targets
        DESTINATION ${CMAKE_INSTALL_CMAKEDIR}
        NAMESPACE nanopb::)

    install(FILES extra/nanopb-config.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/nanopb-config-version.cmake
        DESTINATION ${CMAKE_INSTALL_CMAKEDIR})

    install(FILES pb.h pb_common.h pb_encode.h pb_decode.h
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
endif()

=== docs/Makefile ===
all: index.html concepts.html reference.html security.html migration.html whats_new.html

%.html: %.rst
	rst2html --field-name-limit=32 --stylesheet=lsr.css --link-stylesheet $< $@
	sed -i 's!</head>!<link href="favicon.ico" type="image/x-icon" rel="shortcut icon" />\n</head>!' $@

=== tests/SConstruct ===
Help('''
Type 'scons' to build and run all the available test cases.
It will automatically detect your platform and C compiler and
build appropriately.

You can modify the behavious using following options:
CC          Name of C compiler
CXX         Name of C++ compiler
CCFLAGS     Flags to pass to the C compiler
CXXFLAGS    Flags to pass to the C++ compiler
LINK        Name of linker (usually same as CC)
LINKFLAGS   Flags to pass to linker
LINKLIBS    Flags to pass to linker after object files
PROTOC      Path to protoc binary
PROTOCFLAGS Arguments to pass protoc
NODEFARGS   Do not add the default CCFLAGS

For example, for a clang build, use:
scons CC=clang CXX=clang++
''')

import os
env = Environment(ENV = os.environ, tools = ['default', 'nanopb'])
env.SConsignFile("build/sconsign")
env.Replace(CONFIGUREDIR = "build/config")

if ARGUMENTS.get('PLATFORM') == 'STM32':
    set_stm32_platform(env)
elif ARGUMENTS.get('PLATFORM') == 'AVR':
    set_avr_platform(env)

# Limit memory usage. This is to catch problems like issue #338
try:
    import resource
    soft, hard = resource.getrlimit(resourse.RLIMIT_AS)
    resource.setrlimit(resource.RLIMIT_AS, (100*1024*1024, hard))
except:
    pass

# Allow overriding the compiler with scons CC=???
if 'CC' in ARGUMENTS: env.Replace(CC = ARGUMENTS['CC'])
if 'CXX' in ARGUMENTS: env.Replace(CXX = ARGUMENTS['CXX'])
if 'LINK' in ARGUMENTS: env.Replace(LINK = ARGUMENTS['LINK'])
if 'CCFLAGS' in ARGUMENTS: env.Append(CCFLAGS = ARGUMENTS['CCFLAGS'])
if 'CXXFLAGS' in ARGUMENTS: env.Append(CXXFLAGS = ARGUMENTS['CXXFLAGS'])
if 'LINKFLAGS' in ARGUMENTS: env.Append(LINKFLAGS = ARGUMENTS['LINKFLAGS'])
if 'LINKLIBS' in ARGUMENTS: env.Append(LINKLIBS = ARGUMENTS['LINKLIBS'])
if 'PROTOC' in ARGUMENTS: env.Replace(PROTOC = ARGUMENTS['PROTOC'])
if 'PROTOCFLAGS' in ARGUMENTS: env.Replace(PROTOCFLAGS = ARGUMENTS['PROTOCFLAGS'])
if 'NODEFARGS' in ARGUMENTS: env.Replace(NODEFARGS = ARGUMENTS['NODEFARGS'])

# Add the builders defined in site_init.py
add_nanopb_builders(env)

# Path to the files shared by tests, and to the nanopb core.
env.Append(CPPPATH = ["#../", "$COMMON"])

# Path for finding nanopb.proto
env.Append(PROTOCPATH = '#../generator')

# Check the compilation environment, unless we are just cleaning up.
if not env.GetOption('clean'):
    def check_ccflags(context, flags, linkflags = ''):
        '''Check if given CCFLAGS are supported'''
        context.Message('Checking support for CCFLAGS="%s"... ' % flags)
        oldflags = context.env['CCFLAGS']
        oldlinkflags = context.env['LINKFLAGS']
        context.env.Append(CCFLAGS = flags)
        context.env.Append(LINKFLAGS = linkflags)
        result = context.TryCompile("int main() {return 0;}", '.c')
        context.env.Replace(CCFLAGS = oldflags)
        context.env.Replace(LINKFLAGS = oldlinkflags)
        context.Result(result)
        return result
    
    def check_protocversion(context):
        context.Display("Checking protoc version... ")
        status, output = context.TryAction('$PROTOC --version > $TARGET')
        if status:
            context.Result(str(output.strip()))
        else:
            context.Display("error: %s\n" % output.strip())
            context.did_show_result = 1
            context.Result("3.6.1") # Assumption

    conf = Configure(env, custom_tests =
                     {'CheckCCFLAGS': check_ccflags,
                      'CheckProtocVersion': check_protocversion})

    # If the platform doesn't support C99, use our own header file instead.
    stdbool = conf.CheckCHeader('stdbool.h')
    stdint = conf.CheckCHeader('stdint.h')
    stddef = conf.CheckCHeader('stddef.h')
    string = conf.CheckCHeader('string.h')
    stdlib = conf.CheckCHeader('stdlib.h')
    limits = conf.CheckCHeader('limits.h')
    if not stdbool or not stdint or not stddef or not string or not limits:
        conf.env.Append(CPPDEFINES = {'PB_SYSTEM_HEADER': '\\"pb_syshdr.h\\"'})
        conf.env.Append(CPPPATH = "#../extra")
        conf.env.Append(SYSHDR = '\\"pb_syshdr.h\\"')
        
        if stdbool: conf.env.Append(CPPDEFINES = {'HAVE_STDBOOL_H': 1})
        if stdint: conf.env.Append(CPPDEFINES = {'HAVE_STDINT_H': 1})
        if stddef: conf.env.Append(CPPDEFINES = {'HAVE_STDDEF_H': 1})
        if string: conf.env.Append(CPPDEFINES = {'HAVE_STRING_H': 1})
        if stdlib: conf.env.Append(CPPDEFINES = {'HAVE_STDLIB_H': 1})
        if limits: conf.env.Append(CPPDEFINES = {'HAVE_LIMITS_H': 1})
    
    # Check protoc version
    conf.env['PROTOC_VERSION'] = conf.CheckProtocVersion()

    # Initialize compiler arguments with defaults, unless overridden on
    # command line.
    if not env.get('NODEFARGS'):
        # Check if libmudflap is available (only with GCC)
        if 'gcc' in env['CC']:
            if conf.CheckLib('mudflap'):
                conf.env.Append(CCFLAGS = '-fmudflap')
                conf.env.Append(LINKFLAGS = '-fmudflap')

        # Check if we can use extra strict warning flags (only with GCC)
        extra = '-Wcast-qual -Wlogical-op -Wconversion'
        extra += ' -fstrict-aliasing -Wstrict-aliasing=1'
        extra += ' -Wmissing-prototypes -Wmissing-declarations -Wredundant-decls'
        extra += ' -Wstack-protector '
        if 'gcc' in env['CC']:
            if conf.CheckCCFLAGS(extra):
                conf.env.Append(CORECFLAGS = extra)

        # Check if we can use undefined behaviour sanitizer (only with clang)
        # TODO: Fuzz test triggers the bool sanitizer, figure out whether to
        #       modify the fuzz test or to keep ignoring the check.
        extra = '-fsanitize=undefined,integer -fno-sanitize-recover=undefined,integer '
        if 'clang' in env['CC']:
            if conf.CheckCCFLAGS(extra, linkflags = extra):
                conf.env.Append(CORECFLAGS = extra)
                conf.env.Append(LINKFLAGS = extra)
    
    # End the config stuff
    env = conf.Finish()

if not env.get('NODEFARGS'):
    # Initialize the CCFLAGS according to the compiler
    if 'gcc' in env['CC']:
        # GNU Compiler Collection
        
        # Debug info, warnings as errors
        env.Append(CFLAGS = '-g -Wall -Werror ')
        env.Append(CORECFLAGS = '-Wextra')

        # Pedantic ANSI C. On AVR this doesn't work because we use large
        # enums in some of the tests.
        if env.get("EMBEDDED") != "AVR":
            env.Append(CFLAGS = '-ansi -pedantic')

        # Profiling and coverage
        if not env.get("EMBEDDED"):
            env.Append(CFLAGS = '-fprofile-arcs -ftest-coverage ')
            env.Append(LINKFLAGS = '-g --coverage')


        # We currently need uint64_t anyway, even though ANSI C90 otherwise..
        env.Append(CFLAGS = '-Wno-long-long')
    elif 'clang' in env['CC']:
        # CLang
        env.Append(CFLAGS = '-ansi -g -Wall -Werror')
        env.Append(CORECFLAGS = ' -Wextra -Wcast-qual -Wconversion')
    elif 'cl' in env['CC']:
        # Microsoft Visual C++

        # Debug info on, warning level 2 for tests, warnings as errors
        env.Append(CFLAGS = '/Zi /W2 /WX')
        env.Append(LINKFLAGS = '/DEBUG')

        # More strict checks on the nanopb core
        env.Append(CORECFLAGS = '/W4')

        # Disable warning about sizeof(union{}) construct that is used in
        # message size macros, in e.g. multiple_files testcase. The C construct
        # itself is valid, but quite rare, which causes Visual C++ to give a warning
        # about it.
        env.Append(CFLAGS = '/wd4116')
    elif 'tcc' in env['CC']:
        # Tiny C Compiler
        env.Append(CFLAGS = '-Wall -Werror -g')

    if 'clang' in env['CXX']:
        env.Append(CXXFLAGS = '-g -Wall -Werror -Wextra -Wno-missing-field-initializers')
    elif 'g++' in env['CXX'] or 'gcc' in env['CXX']:
        env.Append(CXXFLAGS = '-g -Wall -Werror -Wextra -Wno-missing-field-initializers')
    elif 'cl' in env['CXX']:
        env.Append(CXXFLAGS = '/Zi /W2 /WX /wd4116 /wd4127')

env.SetDefault(CORECFLAGS = '')

if not env.get("EMBEDDED"):
    valgrind = env.WhereIs('valgrind')
    if valgrind:
        env.SetDefault(VALGRIND = valgrind)

# Make it possible to add commands to the end of linker line
env.SetDefault(LINKLIBS = '')
env.Replace(LINKCOM = env['LINKCOM'] + " $LINKLIBS")

# Place build files under separate folder
import os.path
env['VARIANT_DIR'] = 'build'
env['BUILD'] = '#' + env['VARIANT_DIR']
env['COMMON'] = '#' + env['VARIANT_DIR'] + '/common'

# Include common/SConscript first to make sure its exports are available
# to other SConscripts.
SConscript("common/SConscript", exports = 'env', variant_dir = env['VARIANT_DIR'] + '/common')

# Now include the SConscript files from all subdirectories
for subdir in Glob('*/SConscript') + Glob('regression/*/SConscript'):
    if str(subdir).startswith("common/"): continue
    if str(subdir).startswith("common\\"): continue
    SConscript(subdir, exports = 'env', variant_dir = env['VARIANT_DIR'] + '/' + os.path.dirname(str(subdir)))

=== debian/changelog ===
nanopb (0.4.1-1) unstable; urgency=medium

  * Initial release (closes: #821097).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 03 Feb 2020 22:40:20 +0000

=== debian/control ===
Source: nanopb
Section: devel
Priority: optional
Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends: debhelper-compat (= 12), dh-python, cmake, scons, python3, protobuf-compiler, python3-protobuf
Homepage: https://jpa.kapsi.fi/nanopb/
Standards-Version: 4.4.1

Package: nanopb
Architecture: all
Depends: protobuf-compiler, ${python3:Depends}, ${misc:Depends}
Multi-Arch: foreign
Description: Protocol Buffers with small code size
 Plain-C implementation of Google's Protocol Buffers data format. It is
 targeted at 32 bit microcontrollers, but is also fit for other embedded
 systems with tight (<10 kB ROM, <1 kB RAM) memory constraints.
 .
 This package contains the nanopb generator.

Package: libnanopb-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}
Multi-Arch: same
Description: Protocol Buffers with small code size, development files
 Plain-C implementation of Google's Protocol Buffers data format. It is
 targeted at 32 bit microcontrollers, but is also fit for other embedded
 systems with tight (<10 kB ROM, <1 kB RAM) memory constraints.
 .
 This package contains the development files (headers, static library).

## nanopb 0.4.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project(nanopb C)
 
-set(nanopb_VERSION_STRING nanopb-0.4.1)
+set(nanopb_VERSION_STRING nanopb-0.4.2)
 set(nanopb_SOVERSION 0)
 
 string(REPLACE "nanopb-" "" nanopb_VERSION ${nanopb_VERSION_STRING})
@@ -41,9 +41,9 @@
 if(nanopb_BUILD_GENERATOR)
     set(generator_protos nanopb)
 
-    find_package(PythonInterp 2.7 REQUIRED)
+    find_package(Python REQUIRED)
     execute_process(
-        COMMAND ${PYTHON_EXECUTABLE} -c
+        COMMAND ${Python_EXECUTABLE} -c
             "from distutils import sysconfig; print(sysconfig.get_python_lib(prefix=''))"
         OUTPUT_VARIABLE PYTHON_INSTDIR
         OUTPUT_STRIP_TRAILING_WHITESPACE
@@ -60,7 +60,7 @@
         add_custom_target("generate_${generator_proto_py_file}" ALL DEPENDS ${generator_proto_py_file})
         install(
             FILES ${PROJECT_BINARY_DIR}/${generator_proto_py_file}
-			DESTINATION ${PYTHON_INSTDIR}
+            DESTINATION ${Python_SITELIB}
         )
     endforeach()
 endif()

=== tests/SConstruct ===
--- 
+++ 
@@ -14,20 +14,25 @@
 PROTOC      Path to protoc binary
 PROTOCFLAGS Arguments to pass protoc
 NODEFARGS   Do not add the default CCFLAGS
+NOVALGRIND  Do not use valgrind for memory checks
 
 For example, for a clang build, use:
 scons CC=clang CXX=clang++
 ''')
 
 import os
+import platform
 env = Environment(ENV = os.environ, tools = ['default', 'nanopb'])
 env.SConsignFile("build/sconsign")
 env.Replace(CONFIGUREDIR = "build/config")
 
-if ARGUMENTS.get('PLATFORM') == 'STM32':
-    set_stm32_platform(env)
-elif ARGUMENTS.get('PLATFORM') == 'AVR':
-    set_avr_platform(env)
+if ARGUMENTS.get('PLATFORM'):
+    platform_func = platforms.get(ARGUMENTS.get('PLATFORM'))
+    if not platform_func:
+        print("Supported platforms: " + str(platforms.keys()))
+        raise Exception("Unsupported platform: " + ARGUMENTS.get('PLATFORM'))
+    else:
+        platform_func(env)
 
 # Limit memory usage. This is to catch problems like issue #338
 try:
@@ -36,6 +41,11 @@
     resource.setrlimit(resource.RLIMIT_AS, (100*1024*1024, hard))
 except:
     pass
+
+# On Mac OS X, gcc is usually alias for clang.
+# To avoid problem with default options, use clang directly.
+if platform.system() == "Darwin":
+    env.Replace(CC = "clang", CXX = "clang")
 
 # Allow overriding the compiler with scons CC=???
 if 'CC' in ARGUMENTS: env.Replace(CC = ARGUMENTS['CC'])
@@ -48,6 +58,7 @@
 if 'PROTOC' in ARGUMENTS: env.Replace(PROTOC = ARGUMENTS['PROTOC'])
 if 'PROTOCFLAGS' in ARGUMENTS: env.Replace(PROTOCFLAGS = ARGUMENTS['PROTOCFLAGS'])
 if 'NODEFARGS' in ARGUMENTS: env.Replace(NODEFARGS = ARGUMENTS['NODEFARGS'])
+if 'NOVALGRIND' in ARGUMENTS: env.Replace(NOVALGRIND = ARGUMENTS['NOVALGRIND'])
 
 # Add the builders defined in site_init.py
 add_nanopb_builders(env)
@@ -193,7 +204,7 @@
 
 env.SetDefault(CORECFLAGS = '')
 
-if not env.get("EMBEDDED"):
+if not env.get("EMBEDDED") and not env.get("NOVALGRIND"):
     valgrind = env.WhereIs('valgrind')
     if valgrind:
         env.SetDefault(VALGRIND = valgrind)

=== debian/changelog ===
nanopb (0.4.2-1) unstable; urgency=medium

  * New upstream release.
  * Backport upstream fix for float_double_conversion test failures on MIPS.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 23 Jun 2020 21:11:55 +0200

nanopb (0.4.1+git200620-1) unstable; urgency=medium

  * New git snapshot release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 21 Jun 2020 15:00:16 +0200

nanopb (0.4.1+git200603-1) unstable; urgency=medium

  * New git snapshot release (closes: #962537).
  * Update Standards-Version to 4.5.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 11 Jun 2020 20:20:13 +0200

## nanopb 0.4.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project(nanopb C)
 
-set(nanopb_VERSION_STRING nanopb-0.4.2)
+set(nanopb_VERSION_STRING nanopb-0.4.3)
 set(nanopb_SOVERSION 0)
 
 string(REPLACE "nanopb-" "" nanopb_VERSION ${nanopb_VERSION_STRING})
@@ -60,9 +60,27 @@
         add_custom_target("generate_${generator_proto_py_file}" ALL DEPENDS ${generator_proto_py_file})
         install(
             FILES ${PROJECT_BINARY_DIR}/${generator_proto_py_file}
-            DESTINATION ${Python_SITELIB}
+                  ${generator_proto_file}
+            DESTINATION ${PYTHON_INSTDIR}/proto/
         )
     endforeach()
+endif()
+
+install( FILES generator/proto/_utils.py
+         DESTINATION ${PYTHON_INSTDIR}/proto/ )
+
+if( WIN32 )
+        install(
+            PROGRAMS generator/nanopb_generator.py
+                     generator/protoc-gen-nanopb.bat
+            DESTINATION ${CMAKE_INSTALL_BINDIR}
+        )
+else()
+        install(
+            PROGRAMS generator/nanopb_generator.py
+                     generator/protoc-gen-nanopb
+            DESTINATION ${CMAKE_INSTALL_BINDIR}
+        )
 endif()
 
 if(nanopb_BUILD_RUNTIME)

=== tests/SConstruct ===
--- 
+++ 
@@ -4,6 +4,7 @@
 build appropriately.
 
 You can modify the behavious using following options:
+BUILDDIR    Directory to build into (default "build")
 CC          Name of C compiler
 CXX         Name of C++ compiler
 CCFLAGS     Flags to pass to the C compiler
@@ -22,10 +23,22 @@
 
 import os
 import platform
-env = Environment(ENV = os.environ, tools = ['default', 'nanopb'])
-env.SConsignFile("build/sconsign")
-env.Replace(CONFIGUREDIR = "build/config")
-
+env = Environment(ENV = os.environ)
+
+# Allow giving environment flags on command line.
+list_vars = ['CCFLAGS', 'CXXFLAGS', 'LINKFLAGS', 'LINKLIBS', 'PROTOCFLAGS']
+for var,val in ARGUMENTS.items():
+    if var in list_vars:
+        env.Append(**{var: val})
+    else:
+        env.Replace(**{var: val})
+
+env.SetDefault(BUILDDIR = "build")
+env.SConsignFile(env['BUILDDIR'] + "/sconsign")
+env.Replace(CONFIGUREDIR = env['BUILDDIR'] + "/config")
+
+# If a cross compilation platform is given, apply the environment settings
+# from site_scons/platforms/X/X.py
 if ARGUMENTS.get('PLATFORM'):
     platform_func = platforms.get(ARGUMENTS.get('PLATFORM'))
     if not platform_func:
@@ -34,6 +47,9 @@
     else:
         platform_func(env)
 
+# Load nanopb generator build rules from site_scons/site_tools/nanopb.py
+env.Tool("nanopb")
+
 # Limit memory usage. This is to catch problems like issue #338
 try:
     import resource
@@ -44,21 +60,8 @@
 
 # On Mac OS X, gcc is usually alias for clang.
 # To avoid problem with default options, use clang directly.
-if platform.system() == "Darwin":
-    env.Replace(CC = "clang", CXX = "clang")
-
-# Allow overriding the compiler with scons CC=???
-if 'CC' in ARGUMENTS: env.Replace(CC = ARGUMENTS['CC'])
-if 'CXX' in ARGUMENTS: env.Replace(CXX = ARGUMENTS['CXX'])
-if 'LINK' in ARGUMENTS: env.Replace(LINK = ARGUMENTS['LINK'])
-if 'CCFLAGS' in ARGUMENTS: env.Append(CCFLAGS = ARGUMENTS['CCFLAGS'])
-if 'CXXFLAGS' in ARGUMENTS: env.Append(CXXFLAGS = ARGUMENTS['CXXFLAGS'])
-if 'LINKFLAGS' in ARGUMENTS: env.Append(LINKFLAGS = ARGUMENTS['LINKFLAGS'])
-if 'LINKLIBS' in ARGUMENTS: env.Append(LINKLIBS = ARGUMENTS['LINKLIBS'])
-if 'PROTOC' in ARGUMENTS: env.Replace(PROTOC = ARGUMENTS['PROTOC'])
-if 'PROTOCFLAGS' in ARGUMENTS: env.Replace(PROTOCFLAGS = ARGUMENTS['PROTOCFLAGS'])
-if 'NODEFARGS' in ARGUMENTS: env.Replace(NODEFARGS = ARGUMENTS['NODEFARGS'])
-if 'NOVALGRIND' in ARGUMENTS: env.Replace(NOVALGRIND = ARGUMENTS['NOVALGRIND'])
+if platform.system() == "Darwin" and 'CC' not in ARGUMENTS:
+    env.Replace(CC = "clang", CXX = "clang++")
 
 # Add the builders defined in site_init.py
 add_nanopb_builders(env)
@@ -215,7 +218,7 @@
 
 # Place build files under separate folder
 import os.path
-env['VARIANT_DIR'] = 'build'
+env['VARIANT_DIR'] = env['BUILDDIR']
 env['BUILD'] = '#' + env['VARIANT_DIR']
 env['COMMON'] = '#' + env['VARIANT_DIR'] + '/common'

=== debian/changelog ===
nanopb (0.4.3-1) unstable; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 03 Oct 2020 13:51:33 +0200

## nanopb 0.4.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project(nanopb C)
 
-set(nanopb_VERSION_STRING nanopb-0.4.3)
+set(nanopb_VERSION_STRING nanopb-0.4.4)
 set(nanopb_SOVERSION 0)
 
 string(REPLACE "nanopb-" "" nanopb_VERSION ${nanopb_VERSION_STRING})

=== docs/Makefile ===
INPUTS = index.md concepts.md reference.md security.md migration.md whats_new.md

all: $(INPUTS:.md=.html)

tmp_menu.html: $(INPUTS)
	echo '<div id="index">' > $@
	(echo '<h2>Documentation index</h2>'; \
	 for file in $^; do echo -n '1. ['; sed -n '1 s!^# Nanopb: !! p' $$file; \
	 echo -n "]("; echo $$file | sed 's/.md/.html)/' ; done;) | \
	 pandoc -f markdown -t html5 >> $@
	echo '</div>' >> $@

%.html: %.md tmp_menu.html
	sed '1 s!#!%!' $< | \
	pandoc -s -f markdown -t html5 -c lsr.css --toc --toc-depth=4 \
	 --variable 'header-includes=<link href="favicon.ico" type="image/x-icon" rel="shortcut icon" />' \
	 --indented-code-classes=c \
	 -o $@
	sed -i '/<nav/e cat feedback.html' $@
	sed -i 's/doc_page_name_placeholder/$</' $@
	sed -i 's!<nav[^>]*>!\0<b>Contents:</b>!' $@
	sed -i '/<nav/e cat tmp_menu.html' $@

=== debian/changelog ===
nanopb (0.4.4-2) unstable; urgency=high

  * Fix CVE-2021-21401: invalid free() call with oneofs and PB_ENABLE_MALLOC
    (closes: #985844).


 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 15 Apr 2021 21:54:29 +0200

nanopb (0.4.4-1) unstable; urgency=high

  * New upstream release:
    - fix CVE-2020-26243: decoding specifically formed message can leak
      memory (closes: #975838).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 27 Nov 2020 20:30:08 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends: debhelper-compat (= 12), dh-python, cmake, scons, python3, protobuf-compiler, python3-protobuf
 Homepage: https://jpa.kapsi.fi/nanopb/
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 
 Package: nanopb
 Architecture: all

=== debian/rules ===
#!/usr/bin/make -f
#-*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# enable dynamic allocation support
export DEB_CFLAGS_MAINT_APPEND=-DPB_ENABLE_MALLOC

override_dh_clean:
	dh_clean
	find $(CURDIR) -name \*.pyc -delete
	$(RM) -f $(CURDIR)/generator/proto/nanopb_pb2.py
	$(RM) $(CURDIR)/tests/.sconsign.dblite
	$(RM) -rf $(CURDIR)/tests/.sconf_temp/
	$(RM) -rf $(CURDIR)/tests/build/
	$(RM) $(CURDIR)/tests/config.log

override_dh_auto_build:
	dh_auto_build
	$(MAKE) -C $(CURDIR)/generator/proto/

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd $(CURDIR)/tests/ && scons
endif

%:
	dh $@ --with python3

.PHONY: override_dh_clean override_dh_auto_build override_dh_auto_test

=== debian/watch ===
version=4
https://github.com/nanopb/nanopb/tags .*/v?(\d\S*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## nanopb 0.4.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project(nanopb C)
 
-set(nanopb_VERSION_STRING nanopb-0.4.4)
+set(nanopb_VERSION_STRING nanopb-0.4.5)
 set(nanopb_SOVERSION 0)
 
 string(REPLACE "nanopb-" "" nanopb_VERSION ${nanopb_VERSION_STRING})

=== tests/Makefile ===
all:
	scons

clean:
	scons -c

coverage:
	rm -rf build coverage

	# LCOV does not like the newer gcov format
	scons CC=gcc-4.6 CXX=gcc-4.6

	# Collect the data
	mkdir build/coverage
	lcov --base-directory . --directory build/ --gcov-tool gcov-4.6 -c -o build/coverage/nanopb.info

	# Remove the test code from results
	lcov -r build/coverage/nanopb.info '*tests*' -o build/coverage/nanopb.info

	# Generate HTML
	genhtml -o build/coverage build/coverage/nanopb.info

=== tests/SConstruct ===
--- 
+++ 
@@ -92,10 +92,12 @@
         status, output = context.TryAction('$PROTOC --version > $TARGET')
         if status:
             context.Result(str(output.strip()))
+            return str(output.strip())
         else:
             context.Display("error: %s\n" % output.strip())
             context.did_show_result = 1
-            context.Result("3.6.1") # Assumption
+            context.Result("unknown, assuming 3.6.1")
+            return "3.6.1"
 
     conf = Configure(env, custom_tests =
                      {'CheckCCFLAGS': check_ccflags,

=== examples/cmake_relpath/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(NANOPB_CMAKE_SIMPLE C)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/../../extra)
find_package(Nanopb REQUIRED)
include_directories(${NANOPB_INCLUDE_DIRS})

nanopb_generate_cpp(PROTO_SRCS PROTO_HDRS RELPATH proto
	proto/simple.proto proto/sub/unlucky.proto)

include_directories(${CMAKE_CURRENT_BINARY_DIR})
#add_custom_target(generate_proto_sources DEPENDS ${PROTO_SRCS} ${PROTO_HDRS})
set_source_files_properties(${PROTO_SRCS} ${PROTO_HDRS}
    PROPERTIES GENERATED TRUE)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror -g -O0")

add_executable(simple simple.c ${PROTO_SRCS} ${PROTO_HDRS})

=== generator/proto/Makefile ===
PROTOC?=protoc

all: nanopb_pb2.py

%_pb2.py: %.proto
	$(PROTOC) --python_out=. $<

=== debian/changelog ===
nanopb (0.4.5-2) unstable; urgency=medium

  * Fix build with SCons 4.2.0+ .
  * Update watch file.
  * Update Standards-Version to 4.6.0.1 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 01 Jan 2022 20:44:26 +0100

nanopb (0.4.5-1) unstable; urgency=medium

  * New upstream release.
  * Update debhelper level to 13 .
  * Update Standards-Version to 4.5.1 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 22 Aug 2021 10:58:43 +0200

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: devel
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Build-Depends: debhelper-compat (= 12), dh-python, cmake, scons, python3, protobuf-compiler, python3-protobuf
+Build-Depends: debhelper-compat (= 13), dh-python, cmake, scons, python3, protobuf-compiler, python3-protobuf
 Homepage: https://jpa.kapsi.fi/nanopb/
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0.1
 
 Package: nanopb
 Architecture: all

=== debian/watch ===
version=4
opts=uversionmangle=s/^(SNAPSHOT|RELEASE)\.//;s/(\d+)[_-](\d+)[_-](\d+)/\$1.\$2.\$3/;s/(\d+)[_-](\d+)/\$1.\$2/;s/(\d)[_\.\-\+]?((rc|pre|dev|beta|alpha|b|a)[\-\.]?\d*)$/$1~$2/;s/(\d)[_\.\-\+]?RC[\-\.]?(\d*)$/$1~rc$2/,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//i \
https://github.com/nanopb/nanopb/tags \
(?:|.*/)[vV]?(\d\S*)@ARCHIVE_EXT@

## nanopb 0.4.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project(nanopb C)
 
-set(nanopb_VERSION_STRING nanopb-0.4.5)
+set(nanopb_VERSION_STRING nanopb-0.4.6)
 set(nanopb_SOVERSION 0)
 
 string(REPLACE "nanopb-" "" nanopb_VERSION ${nanopb_VERSION_STRING})
@@ -14,8 +14,9 @@
 option(nanopb_BUILD_GENERATOR "Build the protoc plugin for code generation" ON)
 option(nanopb_MSVC_STATIC_RUNTIME "Link static runtime libraries" ON)
 
-if(NOT DEFINED nanopb_PROTOC_PATH)
-    set(nanopb_PROTOC_PATH "protoc")
+find_program(nanopb_PROTOC_PATH protoc)
+if(NOT EXISTS ${nanopb_PROTOC_PATH})
+    message(FATAL_ERROR "protoc compiler not found")
 endif()
 
 if(NOT DEFINED CMAKE_DEBUG_POSTFIX)
@@ -38,16 +39,16 @@
     set(CMAKE_INSTALL_CMAKEDIR "${CMAKE_INSTALL_LIBDIR}/cmake/nanopb")
 endif()
 
+find_package(Python REQUIRED COMPONENTS Interpreter)
+execute_process(
+    COMMAND ${Python_EXECUTABLE} -c
+        "import os.path, sys, sysconfig; print(os.path.relpath(sysconfig.get_path('purelib'), start=sys.prefix))"
+    OUTPUT_VARIABLE PYTHON_INSTDIR
+    OUTPUT_STRIP_TRAILING_WHITESPACE
+)
+
 if(nanopb_BUILD_GENERATOR)
     set(generator_protos nanopb)
-
-    find_package(Python REQUIRED)
-    execute_process(
-        COMMAND ${Python_EXECUTABLE} -c
-            "from distutils import sysconfig; print(sysconfig.get_python_lib(prefix=''))"
-        OUTPUT_VARIABLE PYTHON_INSTDIR
-        OUTPUT_STRIP_TRAILING_WHITESPACE
-    )
 
     foreach(generator_proto IN LISTS generator_protos)
         string(REGEX REPLACE "([^;]+)" "${PROJECT_SOURCE_DIR}/generator/proto/\\1.proto" generator_proto_file "${generator_proto}")
@@ -64,23 +65,25 @@
             DESTINATION ${PYTHON_INSTDIR}/proto/
         )
     endforeach()
+
+    install( FILES generator/proto/_utils.py
+             DESTINATION ${PYTHON_INSTDIR}/proto/ )
 endif()
 
-install( FILES generator/proto/_utils.py
-         DESTINATION ${PYTHON_INSTDIR}/proto/ )
-
-if( WIN32 )
-        install(
-            PROGRAMS generator/nanopb_generator.py
-                     generator/protoc-gen-nanopb.bat
-            DESTINATION ${CMAKE_INSTALL_BINDIR}
-        )
+if(WIN32)
+    install(
+        PROGRAMS
+            generator/nanopb_generator.py
+            generator/protoc-gen-nanopb.bat
+        DESTINATION ${CMAKE_INSTALL_BINDIR}
+    )
 else()
-        install(
-            PROGRAMS generator/nanopb_generator.py
-                     generator/protoc-gen-nanopb
-            DESTINATION ${CMAKE_INSTALL_BINDIR}
-        )
+    install(
+        PROGRAMS
+            generator/nanopb_generator.py
+            generator/protoc-gen-nanopb
+        DESTINATION ${CMAKE_INSTALL_BINDIR}
+    )
 endif()
 
 if(nanopb_BUILD_RUNTIME)
@@ -97,10 +100,11 @@
             SOVERSION ${nanopb_SOVERSION})
         install(TARGETS protobuf-nanopb EXPORT nanopb-targets
             ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
-	    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
+            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
             RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
         target_include_directories(protobuf-nanopb INTERFACE
-          $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
+            $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
+            $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
         )
     endif()
 
@@ -118,7 +122,8 @@
         install(TARGETS protobuf-nanopb-static EXPORT nanopb-targets
             ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
         target_include_directories(protobuf-nanopb-static INTERFACE
-          $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
+            $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
+	        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
         )
     endif()

=== tests/SConstruct ===
--- 
+++ 
@@ -3,7 +3,7 @@
 It will automatically detect your platform and C compiler and
 build appropriately.
 
-You can modify the behavious using following options:
+You can modify the behaviour using following options:
 BUILDDIR    Directory to build into (default "build")
 CC          Name of C compiler
 CXX         Name of C++ compiler
@@ -162,12 +162,13 @@
         
         # Debug info, warnings as errors
         env.Append(CFLAGS = '-g -Wall -Werror ')
-        env.Append(CORECFLAGS = '-Wextra')
+        env.Append(CORECFLAGS = '-Wextra ')
 
         # Pedantic ANSI C. On AVR this doesn't work because we use large
         # enums in some of the tests.
         if env.get("EMBEDDED") != "AVR":
-            env.Append(CFLAGS = '-ansi -pedantic')
+            env.Append(CFLAGS = '-ansi ')
+            env.Append(CORECFLAGS = '-pedantic ')
 
         # Profiling and coverage
         if not env.get("EMBEDDED"):
@@ -191,6 +192,9 @@
         # More strict checks on the nanopb core
         env.Append(CORECFLAGS = '/W4')
 
+        # Enable C11 standard
+        env.Append(CFLAGS = ' /std:c11 ')
+
         # Disable warning about sizeof(union{}) construct that is used in
         # message size macros, in e.g. multiple_files testcase. The C construct
         # itself is valid, but quite rare, which causes Visual C++ to give a warning
@@ -203,7 +207,7 @@
     if 'clang' in env['CXX']:
         env.Append(CXXFLAGS = '-g -Wall -Werror -Wextra -Wno-missing-field-initializers')
     elif 'g++' in env['CXX'] or 'gcc' in env['CXX']:
-        env.Append(CXXFLAGS = '-g -Wall -Werror -Wextra -Wno-missing-field-initializers')
+        env.Append(CXXFLAGS = '-g -Wall -Werror -Wextra -Wno-missing-field-initializers -std=gnu++11')
     elif 'cl' in env['CXX']:
         env.Append(CXXFLAGS = '/Zi /W2 /WX /wd4116 /wd4127')

=== debian/changelog ===
nanopb (0.4.6-1) unstable; urgency=medium

  * New upstream release.
  * Install examples to development package.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 03 Jul 2022 11:25:18 +0200

nanopb (0.4.5-3) unstable; urgency=medium

  * Add python3-protobuf dependency (closes: #1008318).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 27 Mar 2022 09:03:25 +0200

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 Package: nanopb
 Architecture: all
-Depends: protobuf-compiler, ${python3:Depends}, ${misc:Depends}
+Depends: protobuf-compiler, ${python3:Depends}, python3-protobuf, ${misc:Depends}
 Multi-Arch: foreign
 Description: Protocol Buffers with small code size
  Plain-C implementation of Google's Protocol Buffers data format. It is

## nanopb 0.4.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project(nanopb C)
 
-set(nanopb_VERSION_STRING nanopb-0.4.6)
+set(nanopb_VERSION_STRING nanopb-0.4.7)
 set(nanopb_SOVERSION 0)
 
 string(REPLACE "nanopb-" "" nanopb_VERSION ${nanopb_VERSION_STRING})
@@ -14,7 +14,7 @@
 option(nanopb_BUILD_GENERATOR "Build the protoc plugin for code generation" ON)
 option(nanopb_MSVC_STATIC_RUNTIME "Link static runtime libraries" ON)
 
-find_program(nanopb_PROTOC_PATH protoc)
+find_program(nanopb_PROTOC_PATH protoc HINTS generator-bin generator)
 if(NOT EXISTS ${nanopb_PROTOC_PATH})
     message(FATAL_ERROR "protoc compiler not found")
 endif()
@@ -123,7 +123,7 @@
             ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
         target_include_directories(protobuf-nanopb-static INTERFACE
             $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
-	        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
+            $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
         )
     endif()

=== examples/cmake_relpath/CMakeLists.txt ===
--- 
+++ 
@@ -9,9 +9,6 @@
 	proto/simple.proto proto/sub/unlucky.proto)
 
 include_directories(${CMAKE_CURRENT_BINARY_DIR})
-#add_custom_target(generate_proto_sources DEPENDS ${PROTO_SRCS} ${PROTO_HDRS})
-set_source_files_properties(${PROTO_SRCS} ${PROTO_HDRS}
-    PROPERTIES GENERATED TRUE)
 
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror -g -O0")

=== debian/changelog ===
nanopb (0.4.7-2) unstable; urgency=medium

  * Add python3-pkg-resources as dependency (closes: #1026803).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 18 Jan 2023 21:00:33 +0100

nanopb (0.4.7-1) unstable; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 17 Dec 2022 09:11:44 +0100

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 Package: nanopb
 Architecture: all
-Depends: protobuf-compiler, ${python3:Depends}, python3-protobuf, ${misc:Depends}
+Depends: protobuf-compiler, ${python3:Depends}, python3-pkg-resources, python3-protobuf, ${misc:Depends}
 Multi-Arch: foreign
 Description: Protocol Buffers with small code size
  Plain-C implementation of Google's Protocol Buffers data format. It is

=== debian/rules ===
--- 
+++ 
@@ -25,7 +25,11 @@
 	cd $(CURDIR)/tests/ && scons
 endif
 
+override_dh_installexamples:
+	dh_installexamples -X.gitignore
+
 %:
 	dh $@ --with python3
 
-.PHONY: override_dh_clean override_dh_auto_build override_dh_auto_test
+.PHONY: override_dh_clean override_dh_auto_build override_dh_auto_test \
+	override_dh_installexamples

## nanopb 0.4.8

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14.0)

project(nanopb C)

set(nanopb_VERSION_STRING nanopb-0.4.8)
set(nanopb_SOVERSION 0)

string(REPLACE "nanopb-" "" nanopb_VERSION ${nanopb_VERSION_STRING})

option(BUILD_SHARED_LIBS "Build shared libraries" OFF)
option(BUILD_STATIC_LIBS "Build static libraries" ON)

option(nanopb_BUILD_RUNTIME "Build the headers and libraries needed at runtime" ON)
option(nanopb_BUILD_GENERATOR "Build the protoc plugin for code generation" ON)
option(nanopb_MSVC_STATIC_RUNTIME "Link static runtime libraries" ON)

set(nanopb_PYTHON_INSTDIR_OVERRIDE "" CACHE PATH "Override the default python installation directory with the given path")

find_program(nanopb_PROTOC_PATH protoc HINTS generator-bin generator)
if(NOT EXISTS ${nanopb_PROTOC_PATH})
    message(FATAL_ERROR "protoc compiler not found")
endif()

if(NOT DEFINED CMAKE_DEBUG_POSTFIX)
    set(CMAKE_DEBUG_POSTFIX "d")
endif()

include(GNUInstallDirs)

if(MSVC AND nanopb_MSVC_STATIC_RUNTIME)
    foreach(flag_var
            CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
            CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
        if(${flag_var} MATCHES "/MD")
            string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
        endif(${flag_var} MATCHES "/MD")
    endforeach(flag_var)
endif()

if(NOT DEFINED CMAKE_INSTALL_CMAKEDIR)
    set(CMAKE_INSTALL_CMAKEDIR "${CMAKE_INSTALL_LIBDIR}/cmake/nanopb")
endif()

# Determine Python module installation path
if (NOT nanopb_PYTHON_INSTDIR_OVERRIDE)
    find_package(Python REQUIRED COMPONENTS Interpreter)
    file(TO_CMAKE_PATH "${Python_SITELIB}" PYTHON_INSTDIR)
else()
    set(PYTHON_INSTDIR ${nanopb_PYTHON_INSTDIR_OVERRIDE})
endif()
message(STATUS "Python install dir: ${PYTHON_INSTDIR}")

# Package nanopb generator as Python module 'nanopb'
if(nanopb_BUILD_GENERATOR)
    # Copy Python code files related to the generator
    add_custom_target(nanopb_generator ALL
        COMMAND ${CMAKE_COMMAND} -E make_directory
            ${PROJECT_BINARY_DIR}/nanopb/generator/proto

        COMMAND ${CMAKE_COMMAND} -E copy_if_different
            ${PROJECT_SOURCE_DIR}/generator/proto/_utils.py
            ${PROJECT_SOURCE_DIR}/generator/proto/__init__.py
            ${PROJECT_SOURCE_DIR}/generator/proto/nanopb.proto
            ${PROJECT_BINARY_DIR}/nanopb/generator/proto

        COMMAND ${CMAKE_COMMAND} -E copy_if_different
            ${PROJECT_SOURCE_DIR}/generator/nanopb_generator.py
            ${PROJECT_SOURCE_DIR}/generator/__init__.py
            ${PROJECT_BINARY_DIR}/nanopb/generator

        COMMAND ${CMAKE_COMMAND} -E copy_if_different
            ${PROJECT_SOURCE_DIR}/generator/__init__.py
            ${PROJECT_BINARY_DIR}/nanopb

        COMMAND ${nanopb_PROTOC_PATH}
            --python_out=${PROJECT_BINARY_DIR}/nanopb/generator/proto
            -I${PROJECT_SOURCE_DIR}/generator/proto
            ${PROJECT_SOURCE_DIR}/generator/proto/nanopb.proto
    )



    # Install Python module files
    install(
        DIRECTORY ${PROJECT_BINARY_DIR}/nanopb
        DESTINATION ${PYTHON_INSTDIR}
        FILES_MATCHING
        PATTERN *.py
        PATTERN *.proto
        PATTERN __pycache__ EXCLUDE
    )

    # Generate a wrapper script that calls nanopb.generator Python module when invoked
    configure_file(
        extra/script_wrappers/nanopb_generator.py.in
        ${PROJECT_BINARY_DIR}/nanopb_generator.py
    )
    install(
        PROGRAMS ${PROJECT_BINARY_DIR}/nanopb_generator.py
        DESTINATION ${CMAKE_INSTALL_BINDIR}
    )

    # Install shell/bat script wrappers for invoking nanopb_generator.py.
    # protoc-gen-nanopb is automatically used by protoc when --nanopb_out= option is used.
    if(WIN32)
        # Include the full path to Python executable in Windows .bat scripts, as it is not in PATH on all systems
        file(READ generator/protoc-gen-nanopb.bat FILE_CONTENTS)
        string(REPLACE "python" ${Python_EXECUTABLE} FILE_CONTENTS "${FILE_CONTENTS}")
        file(WRITE ${PROJECT_BINARY_DIR}/protoc-gen-nanopb.bat "${FILE_CONTENTS}")

        file(READ generator/nanopb_generator.bat FILE_CONTENTS)
        string(REPLACE "python" ${Python_EXECUTABLE} FILE_CONTENTS "${FILE_CONTENTS}")
        file(WRITE ${PROJECT_BINARY_DIR}/nanopb_generator.bat "${FILE_CONTENTS}")

        install(
            PROGRAMS
                ${PROJECT_BINARY_DIR}/protoc-gen-nanopb.bat
                ${PROJECT_BINARY_DIR}/nanopb_generator.bat
            DESTINATION ${CMAKE_INSTALL_BINDIR}
        )
    else()
        # Linux/Mac scripts currently use python3 from PATH
        install(
            PROGRAMS
                generator/protoc-gen-nanopb
                generator/nanopb_generator
            DESTINATION ${CMAKE_INSTALL_BINDIR}
        )
    endif()
endif()

if(nanopb_BUILD_RUNTIME)
    if(BUILD_SHARED_LIBS)
        add_library(protobuf-nanopb SHARED
            pb.h
            pb_common.h
            pb_common.c
            pb_encode.h
            pb_encode.c
            pb_decode.h
            pb_decode.c)
        set_target_properties(protobuf-nanopb PROPERTIES
            SOVERSION ${nanopb_SOVERSION})
        install(TARGETS protobuf-nanopb EXPORT nanopb-targets
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
        target_include_directories(protobuf-nanopb INTERFACE
            $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/nanopb>
            $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
        )
    endif()

    if(BUILD_STATIC_LIBS)
        add_library(protobuf-nanopb-static STATIC
            pb.h
            pb_common.h
            pb_common.c
            pb_encode.h
            pb_encode.c
            pb_decode.h
            pb_decode.c)
        set_target_properties(protobuf-nanopb-static PROPERTIES
            OUTPUT_NAME protobuf-nanopb)
        install(TARGETS protobuf-nanopb-static EXPORT nanopb-targets
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
        target_include_directories(protobuf-nanopb-static INTERFACE
            $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/nanopb>
            $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
        )
    endif()

    configure_file(extra/nanopb-config-version.cmake.in
        nanopb-config-version.cmake @ONLY)

    install(EXPORT nanopb-targets
        DESTINATION ${CMAKE_INSTALL_CMAKEDIR}
        NAMESPACE nanopb::)

    install(FILES extra/nanopb-config.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/nanopb-config-version.cmake
        DESTINATION ${CMAKE_INSTALL_CMAKEDIR})

    install(FILES pb.h pb_common.h pb_encode.h pb_decode.h
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/nanopb)
endif()

=== extra/requirements.txt ===
grpcio-tools==1.51.3

=== tests/SConstruct ===
--- 
+++ 
@@ -76,7 +76,7 @@
 if not env.GetOption('clean'):
     def check_ccflags(context, flags, linkflags = ''):
         '''Check if given CCFLAGS are supported'''
-        context.Message('Checking support for CCFLAGS="%s"... ' % flags)
+        context.Message('Checking support for CCFLAGS="%s" LINKFLAGS="%s"... ' % (flags, linkflags))
         oldflags = context.env['CCFLAGS']
         oldlinkflags = context.env['LINKFLAGS']
         context.env.Append(CCFLAGS = flags)
@@ -122,6 +122,10 @@
         if stdlib: conf.env.Append(CPPDEFINES = {'HAVE_STDLIB_H': 1})
         if limits: conf.env.Append(CPPDEFINES = {'HAVE_LIMITS_H': 1})
     
+    # Some platforms need libm for isnan()
+    if conf.CheckCCFLAGS('', linkflags = '-lm'):
+        conf.env.Append(LINKFLAGS = '-lm')
+
     # Check protoc version
     conf.env['PROTOC_VERSION'] = conf.CheckProtocVersion()

=== debian/changelog ===
nanopb (0.4.8-1) unstable; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 18 Nov 2023 21:46:38 +0100

nanopb (0.4.7-3) unstable; urgency=medium

  * Fix Python installation path (closes: #1052880).
  * Add FindNanopb.cmake to libnanopb-dev (closes: #1040487).
  * Use no for Rules-Requires-Root.
  * Update Standards-Version to 4.6.2 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 27 Sep 2023 21:49:01 +0200

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,9 @@
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends: debhelper-compat (= 13), dh-python, cmake, scons, python3, protobuf-compiler, python3-protobuf
+Standards-Version: 4.6.2
+Rules-Requires-Root: no
 Homepage: https://jpa.kapsi.fi/nanopb/
-Standards-Version: 4.6.0.1
 
 Package: nanopb
 Architecture: all

=== debian/rules ===
--- 
+++ 
@@ -29,7 +29,7 @@
 	dh_installexamples -X.gitignore
 
 %:
-	dh $@ --with python3
+	dh $@ --buildsystem=cmake --with python3
 
 .PHONY: override_dh_clean override_dh_auto_build override_dh_auto_test \
 	override_dh_installexamples
